codeforces 768D Jon and Orbs


D. Jon and Orbs
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Jon Snow is on the lookout for some orbs required to defeat the white walkers. There are k different types of orbs and he needs at least one of each. One orb spawns daily at the base of a Weirwood tree north of the wall. The probability of this orb being of any kind is equal. As the north of wall is full of dangers, he wants to know the minimum number of days he should wait before sending a ranger to collect the orbs such that the probability of him getting at least one of each kind of orb is at least , where ε < 10 - 7.

To better prepare himself, he wants to know the answer for q different values of pi. Since he is busy designing the battle strategy with Sam, he asks you for your help.

Input

First line consists of two space separated integers kq (1 ≤ k, q ≤ 1000) — number of different kinds of orbs and number of queries respectively.

Each of the next q lines contain a single integer pi (1 ≤ pi ≤ 1000) — i-th query.

Output

Output q lines. On i-th of them output single integer — answer for i-th query.

Examples
input
1 1
1
output
1
input
2 2
1
2
output
2
2

题意:有k种水晶,每天生产其中一种,生产每种水晶的概率是均等的,有q次询问,问至少需要几天每一种水晶都存在的概率>p/2000。

思路:听说是概率dp,表示没接触过,对我来说和普通的dp没什么两样。。。。dp[i][j]表示第i天生产了j种水晶的概率,很明显有dp转移方程dp[i][j]=dp[i-1][j-1]*(k-j+1)/k+dp[i-1][j]*j/k,因为p范围是1~1000,所以跑到超过范围我们就不用跑了,用滑动窗口的技巧记录1~1000的答案,然后就能O(1)查询了。下面给代码:

#include<cstdio>  
#include<algorithm>  
#include<cstring>  
#include<iostream>  
#include<cmath>  
#include<queue>  
#include<functional>  
typedef long long LL;
using namespace std;
#define maxn 1005
#define ll l,mid,now<<1  
#define rr mid+1,r,now<<1|1  
#define lson l1,mid,l2,r2,now<<1  
#define rson mid+1,r1,l2,r2,now<<1|1  
#define inf 0x3f3f3f3f  
const int mod = 1e9 + 7;
double dp[10 * maxn][maxn];
int ans[maxn];
int main(){
	int k, q;
	scanf("%d%d", &k, &q);
	dp[0][0] = 1;
	for (int i = 1; ; i++){
		dp[i][0] = 0;
		for (int j = 1; j <= k; j++){
			dp[i][j] = dp[i - 1][j - 1] * ((k - j + 1.0) / k) + dp[i - 1][j] * j / k;
		}
		if (dp[i][k] * 2 >= 1)
			break;
	}
	int pos = 1;
	for (int i = 1; i <= 1000; i++){
		while (dp[pos][k] * 2000 < i)
			pos++;
		ans[i] = pos;
	}
	while (q--){
		int p;
		scanf("%d", &p);
		printf("%d\n", ans[p]);
	}
}


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值